unit BridgeGVModule;

interface

uses
	Windows, SysUtils, ShellApi, ActiveX,
	SysUtilsW,
	{$IFNDEF EXTENSION}LObjects, {$ENDIF} LDDEMan, EOFileIntf;

type
	TFireFileCopyAction = class(TInterfacedObject, IAction, IObserver)
	private
		FChecked: Boolean;
		FPreviewing: WideString;
		{IActionItem}
		function GetText: WideString;
		function GetChecked: Boolean;
		function GetItems: IActionItems;
		function Execute: Boolean;
		{IAction}
		function GetName: string;
		function GetHint: WideString;
		function GetEnabled: Boolean;
		{IObserver}
		procedure Observe;
	protected
		procedure CloseGV;
	public
		destructor Destroy; override;
	end;

	TGlobalExtension = class(TInterfacedObject, IExtension, IExtensionInfo, IThreadHandler)
	private
		{IExtension}
		procedure Initialize;
		procedure Finalize;
		{IExtensionInfo}
		function GetName: WideString;
		procedure Dialog;
		{IThreadHandler}
		procedure ThreadBegun(const AThread: IInterface);
		procedure ThreadEnded(const AThread: IInterface);
	end;

const
	GV_EXE1 = 'C:\Progra~1\GV\GV.EXE';
	GV_EXE2 = 'C:\Progra~1\Accessories\GV\GV.EXE';

implementation

procedure WaitAndRestore;
var
	T: THandle;
	OrgPri: Integer;
begin
	T := Windows.GetCurrentThread;
	OrgPri := GetThreadPriority(T);
	SetThreadPriority(T, THREAD_PRIORITY_IDLE);
	while GetForegroundWindow = GetActiveWindow do
		Sleep(100);
	SetThreadPriority(T, OrgPri);
	repeat
		SetForegroundWindow(GetActiveWindow);
	until GetForegroundWindow = GetActiveWindow;

	{FX肪肻ȃWbNAۂɂ͓ɖȂĂȂ̂ł悵I}
end;

{ TFireFileCopyAction }

procedure TFireFileCopyAction.CloseGV;
begin
	if FChecked then
	begin
		FChecked := False;

		EnableDDE(False);
		SendDDECommand('GV', 'Display', '[ExitGV()]');
		DisableDDE(False);
	end;
end;

destructor TFireFileCopyAction.Destroy;
begin
	CloseGV;
	inherited;
end;

function TFireFileCopyAction.Execute: Boolean;
begin
	if FChecked then
		CloseGV
	else
	begin
		FChecked := True;
		if WinExec(GV_EXE1 + ' /DDE', SW_SHOW) < 32 then
			WinExec(GV_EXE2 + ' /DDE', SW_SHOW);

		WaitAndRestore;
	end;
	Result := True
end;

function TFireFileCopyAction.GetChecked: Boolean;
begin
	Result := FChecked
end;

function TFireFileCopyAction.GetEnabled: Boolean;
begin
	Result := True
end;

function TFireFileCopyAction.GetHint: WideString;
begin
	Result := 'GVpĉ摜vr['
end;

function TFireFileCopyAction.GetItems: IActionItems;
begin
	Result := nil
end;

function TFireFileCopyAction.GetName: string;
begin
	Result := 'PreviewWithGV'
end;

function TFireFileCopyAction.GetText: WideString;
begin
	Result := 'GVŃvr['
end;

procedure TFireFileCopyAction.Observe;
var
	View: IView;
	FileName, Ext: WideString;
begin
	if FChecked then
	begin
		View := (GetCurrentThread as IEOFileThread).ActiveView;
		if View.FocusedFile <> nil then
		begin
			with View.FocusedFile^ do SetString(FileName, Name, NameLength);
			FileName := IncludeTrailingPathDelimiter(View.Model.Path.Directory) + FileName;
			if FileName <> FPreviewing then
			begin
				Ext := ExtractFileExt(FileName);
				if WideSameText(Ext, '.bmp') or WideSameText(Ext, '.png') or
								WideSameText(Ext, '.jpg') or WideSameText(Ext, '.jpeg') then
				begin
					EnableDDE(False);
					SendDDECommand('GV', 'Display', '[FileOpen("' + FileName + '")]');
					DisableDDE(False);
					WaitAndRestore;
					SetForegroundWindow(GetActiveWindow); {Foreground߂}
					FPreviewing := FileName;
				end
			end;
		end
	end;
end;

{ TGlobalExtension }

procedure TGlobalExtension.Dialog;
const
	S = 'GV͂Ƃт́A'#13#10'ubWYT̒앨ł.';
begin
	MessageBoxW(0, S, 'GVubW', MB_ICONINFORMATION)
end;

procedure TGlobalExtension.Finalize;
begin
end;

function TGlobalExtension.GetName: WideString;
begin
	Result := 'GVubW'
end;

procedure TGlobalExtension.Initialize;
begin
end;

procedure TGlobalExtension.ThreadBegun(const AThread: IInterface);
var
	Action: IAction;
begin
	Action := TFireFileCopyAction.Create;

	//Xbh[JANVo^
	(AThread as IActionManager).Attach(Action);

	//Ďo^
	(AThread as IObservable).Attach(Action as IObserver);
end;

procedure TGlobalExtension.ThreadEnded(const AThread: IInterface);
begin
end;

procedure Register;
begin
	(GetApplication as IExtensionManager).RegisterExtension(TGlobalExtension.Create);
end;

initialization

	if GetInterfaceVersion = EOFileIntf.InterfaceVersion then
		Register;

end.
